#include ..\formbrowser.h

#Define d_Pcl    Alen(toTree.plist,1)
#define d_Mcl    Alen(toTree.mList,1)
#Define d_HPcl    Alen(toTree.hPList,1)
#Define d_HMcl    Alen(toTree.hMList,1)
#Define d_NameProp Alltrim(Left(lcProp,At("=",lcProp)-1))
#Define d_NameHProp Alltrim(Left(aHprop(iH),At("=",aHprop(iH))-1))
#define d_lProperties .t.
#define d_lMethods .f.

*!*    *----------------------------------------------------------------------------------------- CreateTblForm
Procedure CreateTblForm(oSource as Form,tcPathVS,toRoot)
    *Procedure CreateTblForm(oSource as Form,tcPathVS)
    With oSource

        *       toRoot = oSource.toRoot
        cPathOfThisFile =Justpath(Substr(Sys(16),Iif(Sys(16)="PROCEDURE",At(" ",Sys(16),2),1)))
        cFile = cPathOfThisFile +"\temp\"

        Store Sys(2015) to  lcUniqueName
        toRoot =  GetRoot(oSource,"Form")
        * place la racine sur l'objet et non le conteneur de l'objet
        * un vcx est un formset.form.unObjet
        * si Vcx et "toRoot.controls(1)")="U" --> c'est une classe formulaire
        toRoot = Iif(JustExt(Lower(tcPathVS))="vcx",Iif(type("toRoot.controls(1)")="U",toRoot,toRoot.controls(1)),toRoot)

        If Directory(cFile)=.F.
            Mkdir (cFile)
        Endif
        &&    Cd (cFile)
  
        #if d_lTableDeSuivit
            tsIns(oSource.name,left(sys(16),at(":",Sys(16))-2), tcPathVS , toRoot.name )
        #endif
  
        If JustExt(m.tcPathVS)="scx"
            toRoot.SaveAs(cFile+lcUniqueName)
        Else
            toRoot.SaveAsClass(cFile+lcUniqueName, toRoot.name )
        endif
        Use (cFile+lcUniqueName+"."+JustExt(tcPathVS)) In 0 Exclusive


    endwith

    Return lcUniqueName
EndProc



Procedure GetHwnd()
    Local oApi as foxtool of ".\commun\utility.vcx"
    oApi=NewObject("foxtool",".\commun\utility.vcx")
    Return oApi.get_w_on_top_handle()

endproc
*!*    *----------------------------------------------------------------------------------------- AddItemOfGroup
*!*    Procedure AddItemOfGroup
*!*        Lparameters toTree,toNode,toObj,tcNameObj,tcKey,tnObjs,tlProperties
*!*        * Optionbutton -- TabIndex
*!*        * Commandbutton -- TabIndex
*!*        * Page          -- PageOrder
*!*        * Column   -- ColumnOrder
*!*        *!*        For each toO in toObj.objects
*!*        *!*            If tcNameObj = toO.name
*!*        *!*                toObj = toO
*!*        *!*                Exit
*!*        *!*            EndIf
*!*        *!*        EndFor
*!*        toObj = toObj.Parent.Objects(Iif(Val(Right(Left(tcNameObj,At(".",tcNameObj)-1),3))=0,Iif(Val(Right(Left(tcNameObj,At(".",tcNameObj)-1),2))=0,1,2),3))
*!*        tnObjs = tnObjs - 1
*!*        toTree.cNop = toObj.name
*!*        *    toNode = toTree.MkTree(toObj,toNode,.t.)
*!*        loNode = toTree.MkTree(toObj,toNode,.t.)
*!*        tcKey= Iif(tlProperties,AddPropMethNode(toTree,loNode),AddNodeMethode(toTree,toNode))

*!*    EndProc
*----------------------------------------------------------------------------------------- AddPropMethNode
Procedure AddPropMethNode
    Lparameters toTree,toNode as MSComctlLib.Node,loObj as Object
    * clef pour la Node Properties

    Private gcPkey,gcMKey

    #define d_cPKey  "kp"+Transform(toTree.Nodes.Count)
    #define d_cMkey  "km"+Transform(toTree.Nodes.Count)
    #define d_cFullPath loNodes.Item(loNodes.Count).parent.parent.fullpath
    gcPkey = d_cPKey
    gcMKey = d_cMkey
    Local ;
        loNodes as MSComctlLib.Nodes ,;
        loLastNode as MSComctlLib.Node ,;
        lSousItem as Logical 
        *,;
        liTableVS as Integer


    loNodes = toTree.Nodes


    * Ajouter la node Properties au parent toNode
    cFullPath = loNodes.Item(toNode.Key).Fullpath
    loNodes.Add( toNode,4 ,gcPkey ,"Properties","imgP" )
    loPropNode = loNodes.Item(loNodes.Count)
    loNodes.Add( toNode,4 ,gcMKey ,"Methods","imgM" )
    loMethNode = loNodes.Item(loNodes.Count)

    #if d_lPropertiesEnsureVisible ==.t.
        loNodes.Item(loNodes.Count).EnsureVisible
    #endif
    
    Select (m.toTree.tableVS)
*!*        m.liTableVS=Alen(m.toTree.parent.aCFC,1)
*!*        Select (m.toTree.parent.aCFC[m.liTableVS,2])
    With m.toTree
        oNode = loNodes.Item(loPropNode.index).parent.parent
        Local ii as Integer
        ii = Iif(Type("oNode.text")="C",Ascan(.aSubCtrlInfo,oNode.text,1,-1,1,8),0)+;
            Iif(Type("oNode.parent.text")="C",Ascan(.aSubCtrlInfo,oNode.parent.text,1,-1,1,8),0)

        lnRecno = Recno()
        Locate for ;
            Parent = Left(cFullPath,rAt(".",cFullPath)-1) ;
            and ;
            objname = m.loObj.name


        If ii>0 and Empty(.aSubCtrlInfo(ii,2))=.f.  and !Found()
            Locate for Recno()= lnRecno
            * charge les proprits d'un sous control

            lcProp    = ChargePropertiesNode(toTree,loNodes,;
                ;
                Iif(ii=0,"",.aSubCtrlInfo(ii,2)),;
                ;
                Chrtran(Left(.aSubCtrlInfo(ii,2),At(".",.aSubCtrlInfo(ii,2))),CR,""))


            lcMeth = Iif(Empty(.aSubCtrlInfo(ii,3)),"", ChargeMethodNode(toTree,loNodes,;
                ;
                Iif(ii=0,"",.aSubCtrlInfo(ii,3)),;
                ;
                d_cFullPath))

            * retirer l'item si vide
            * retirer l'item si vide
            *            If Empty(Substr(.aSubCtrlInfo(ii,2),At(lcProp,.aSubCtrlInfo(ii,2))+Len(lcProp)))
            If Empty(Substr(.aSubCtrlInfo(ii,2),At(lcProp,.aSubCtrlInfo(ii,2))))
                Adel(.aSubCtrlInfo,ii,1)
                Declare .aSubCtrlInfo(Alen(.aSubCtrlInfo,1)-Iif(Alen(.aSubCtrlInfo,1)=1,0,1),3)
            EndIf


        else

            If Found()
                lRegularItem = .t.
                = ChargePropertiesNode(toTree,loNodes,properties,"")
                = Iif(Empty(methods),"",;
                    ; && formulaire, loNodes, fullpath
                ChargeMethodNode(toTree,loNodes,CreateTableMeth(d_cFullPath,methods),d_cFullPath))
            Else
                If "."$Left(lcProp,At("=",lcProp))
                    m.loNodes.Item(loNodes.Count).Tag=Substr(properties,At(lcProp,properties))
                    * exit
                EndIf
            endif
        EndIf
    endwith

    Select (toTree.tableVS)


    Return d_cPKey
EndProc

Procedure CreateTableMeth(cPath,tcMeth)

    Create Cursor (Sys(2015)) ( flM c(200), fullpath c(200))
    Index on fullpath tag fullpath
    lnProp = ALines(laMeth,tcMeth,1+4)
    Declare laMeth(Alen(laMeth,1),1)
    Append From array laMeth fOR flM="PROCEDURE "
    *    replace all flM with Substr(flM,At(" ",flM)+1),fullpath with cpath
    replace all fullpath with Left(cPath+Left("."+Substr(flM,At(" ",flM)+1),Rat(".","."+Substr(flM,At(" ",flM)+1))),Len(cPath+Left("."+Substr(flM,At(" ",flM)+1),Rat(".","."+Substr(flM,At(" ",flM)+1))))-1),;
        flM with Substr(flM,rAt(".",Chrtran(Alltrim(flM)," ","."))+1)

    * Index ON Right("0"+Transform(Occurs(".",Left(flM,At(" ",flM+" ")))),2)+flM tag ndot


    Return Alias()

    *----------------------------------------------------------------------------------------- ChargeMethodNode
Procedure ChargeMethodNode
    Lparameters toTree as Form ,;
        toNodes as MSComctlLib.Nodes ,;
        tcAlias as Character ,;
        tcFPath as Character

    Local ;
        lnFin as Character, ;
        lcProc as Character,;
        lcNameProc as Character, ;
        lcCurrAlias as Character

    Select (tcAlias)
    locate
    Scan for fullpath = Padr(m.tcFPath,Fsize("fullpath"),Space(1))

        Declare toTree.mList(Iif(Empty(toTree.mList(d_Mcl)),0,1)+d_Mcl)

        toNodes.Add( ;
            ; && clef de la node
        gcMKey,4 ,;
            ; && clef parent
        "m"+Transform(d_Mcl) ,;
            ; && limine le nom de l'objet dans les sous objet
        Alltrim(flM),;
            ; && node icone
        "imgM"    )

        toNodes.Item(toNodes.Count).Expanded=.T.
        * toTree.mList(d_Mcl)=cFullPath+"."+d_cNameProc
        toTree.mList(d_Mcl)= Alltrim(fullpath)+"."+flM

        #if d_lPropertiesEnsureVisible ==.t.
            toNodes.Item(toNodes.Count).EnsureVisible
        #endif
        *       m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1

        *  toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(lnFin=1,"",Substr(tcMeth,lnFin))
        * skip
        *toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(Eof(m.tcAlias),"",m.tcAlias)
        *   m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1
    endscan
    Delete For  fullpath = Padr(m.tcFPath,Fsize("fullpath"),Space(1))
    Locate
    If Eof()
        Use in (m.tcAlias)
        toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3)=""
    Else
        toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3)= m.tcAlias
    EndIf



    Return

    If Empty(m.tcNameSousCtlr)==.f. and Seek( "01"+m.tcNameSousCtlr , m.tcAlias  , 1 )
        replace flM with Strtran(flM , m.tcNameSousCtlr+".","") ;
            for "0"+Transform(Occurs(".",flM))+flM= "01"+m.tcNameSousCtlr
    endif

    Locate

    * m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1
    * #define d_cProc  Left(fld,At(crlf,tcMeth))
    #define d_cNameProc  Alltrim(Substr(flM,At(" ",flM)))

    If ;
            toNodes.Item(toNodes.Count).parent.parent.text = ;
            Iif(occurs(".",tcNameSousCtlr)<1,"",left(tcNameSousCtlr,rAt(".",tcNameSousCtlr)-1))

        * tcMeth = Iif(Empty(tcNameSousCtlr),tcMeth,Strtran(tcMeth,Alltrim(tcNameSousCtlr),"PROCEDURE "))
        Local llterminer

        Do While Eof(m.tcAlias)==.f. and m.llterminer==.f.

            Do case
                Case "." $ flM
                    toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3)= m.tcAlias
                    m.llterminer=.t.
                    exit
                Otherwise
                    Do while At(".",flM)==0 and Eof(m.tcAlias)==.f.

                        Declare toTree.mList(Iif(Empty(toTree.mList(d_Mcl)),0,1)+d_Mcl)

                        toNodes.Add( ;
                            ; && clef de la node
                        gcMKey,4 ,;
                            ; && clef parent
                        "m"+Transform(d_Mcl) ,;
                            ; && limine le nom de l'objet dans les sous objet
                        Alltrim(flM),;
                            ; && node icone
                        "imgM"    )

                        toNodes.Item(toNodes.Count).Expanded=.T.
                        toTree.mList(d_Mcl)=cFullPath+"."+d_cNameProc

                        #if d_lMethodsEnsureVisible ==.t.
                            toNodes.Item(toNodes.Count).EnsureVisible
                        #endif
                        *       m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1

                        *  toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(lnFin=1,"",Substr(tcMeth,lnFin))
                        skip
                        toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(Eof(m.tcAlias),"",m.tcAlias)
                        *   m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1

                    enddo




            EndCase
        enddo

    EndIf
    If Empty(toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3))
        Use in (m.tcAlias)
    Else
        Delete for Occurs(".",flM)=0 in m.tcAlias
    endif

EndProc

Procedure AddMeth(toTree,toNodes)

    Declare toTree.mList(Iif(Empty(toTree.mList(d_Mcl)),0,1)+d_Mcl)

    toNodes.Add( ;
        ; && clef de la node
    gcMKey,4 ,;
        ; && clef parent
    "m"+Transform(d_Mcl) ,;
        ; && limine le nom de l'objet dans les sous objet
    Alltrim(flM),;
        ; && node icone
    "imgM"    )

    toNodes.Item(toNodes.Count).Expanded=.T.
    * toTree.mList(d_Mcl)=cFullPath+"."+d_cNameProc
    toTree.mList(d_Mcl)= Alltrim(fullpath)+"."+flM
    #if d_lMethodsEnsureVisible ==.t.
        toNodes.Item(toNodes.Count).EnsureVisible
    #endif
    *       m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1

    *  toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(lnFin=1,"",Substr(tcMeth,lnFin))
    skip
    toTree.aSubCtrlInfo(Alen(toTree.aSubCtrlInfo,1),3) = Iif(Eof(m.tcAlias),"",m.tcAlias)
    *   m.lnFin = At(Chr(10)+"PROCEDURE ",tcMeth)+1

endproc
*----------------------------------------------------------------------------------------- ChargePropertiesNode
Procedure ChargePropertiesNode
    Lparameters toTree as Form ,;
        toNodes as MSComctlLib.Nodes ,;
        tcProperties as Character ,;
        tcNameSousCtlr as Character

    Local lnFin as Integer ,;
        lcSubObjPrp as Character ,;
        lcProp as Character

    lnFin = Alines(aProperty,tcProperties ,4)
    m.lcSubObjPrp = ""

    If  Ascan(aProperty,"_memberdata") > 0
        Adel(aProperty,Ascan(aProperty,"_memberdata"))
        Declare aProperty(Alen(aProperty,1)-1)
    Endif

    For each lcProp in aProperty

        If "."$Left(lcProp,At("=",lcProp))==.f.
            *        If lcProp="_memberdata" ==.f. and "."$Left(lcProp,At("=",lcProp))==.f.
            Declare toTree.plist(Iif(Empty(toTree.plist(d_Pcl)),0,1)+d_Pcl)

            toNodes.Add( ;
                ; && clef de la node
            gcPkey,4 ,;
                ; && clef parent
            "p"+Transform(d_Pcl) ,;
                ; && limine le nom de l'objet dans les sous objet
            Substr(lcProp,Iif(lcProp=toTree.cNop,Len(toTree.cNop)+1,1)),;
                ; && node icone
            "imgP"    )

            toNodes.Item(toNodes.Count).Expanded=.T.
            toTree.plist(d_Pcl)=cFullPath+"."+d_NameProp

            #if d_lPropertiesEnsureVisible ==.t.
                toNodes.Item(toNodes.Count).EnsureVisible
            #endif
        Else
            If tcNameSousCtlr == Left(lcProp,At(".",Left(lcProp,At("=",lcProp))))
                If Occurs(".",Left(lcProp,At(" ",lcProp+" ")))>1
                    m.lcSubObjPrp = Iif(Empty(m.lcSubObjPrp),"",m.lcSubObjPrp+Chr(13))+ Substr(m.lcProp,At(".",m.lcProp)+1)
                    Loop
                endif
                Declare toTree.plist(Iif(Empty(toTree.plist(d_Pcl)),0,1)+d_Pcl)

                toNodes.Add( ;
                    ; && clef de la node
                gcPkey,4 ,;
                    ; && clef parent
                "p"+Transform(d_Pcl) ,;
                    ; && limine le nom de l'objet dans les sous objet
                Substr(lcProp,Len(tcNameSousCtlr)+1),;
                    ; && node icone
                "imgP"    )


                toNodes.Item(toNodes.Count).Expanded=.T.
                toTree.plist(d_Pcl)=cFullPath+"."+d_NameProp
                #if d_lPropertiesEnsureVisible == .t.
                    toNodes.Item(toNodes.Count).EnsureVisible
                #endif
            Else
                * Mettre l'information des sous-objets de conteneurs tels
                * Grid         -- column
                * commandgroup -- commandbutton
                * optiongroup  -- optionButton
                *!*                    oNode = toNodes.Item(toNodes.Count)
                *!*                    oNode = oNode.Parent
                *!*                    Do while oNode.text=="Properties"==.f.
                *!*                        oNode = oNode.Parent
                *!*
                *!*                    enddo

                oNode = toNodes.Item(toNodes.Count).Parent.parent  && sous-groupe ou le groupeCtrl

                With toTree
                    lcProperties = Substr(tcProperties,At(lcProp,tcProperties))
                    * ErrlcProperties = Substr(properties,At(lcProp,properties))
                    Do case
                        case Empty(.aSubCtrlInfo)
                            .aSubCtrlInfo(1,1)= oNode.text
                            .aSubCtrlInfo(1,2)= m.lcSubObjPrp + CR + lcProperties

                        Case Ascan(.aSubCtrlInfo,oNode.text,1,-1,1,8)>0
                            .aSubCtrlInfo(Ascan(.aSubCtrlInfo,oNode.text,1,-1,1,8),2)= m.lcSubObjPrp + CR + lcProperties

                        Case Ascan(.aSubCtrlInfo,oNode.parent.text,1,-1,1,8)>0

                            .aSubCtrlInfo(Ascan(.aSubCtrlInfo,oNode.parent.text,1,-1,1,8),2)= m.lcSubObjPrp + CR + lcProperties


                        Otherwise
                            Declare .aSubCtrlInfo(Alen(.aSubCtrlInfo,1)+1,3)
                            .aSubCtrlInfo(Alen(.aSubCtrlInfo,1),1)=oNode.text
                            .aSubCtrlInfo(Alen(.aSubCtrlInfo,1),2)= m.lcSubObjPrp + CR + lcProperties
                    endcase

                    Exit
                endwith

            EndIf
        endif

    endfor
    Return lcProp
endproc

*!*    *!*    *----------------------------------------------------------------------------------------- AddNodeMethode
*!*    *!*    Procedure AddNodeMethode(toTree,toNode,tcMethods)

*!*    *!*    endProc

*!*    *!*    Procedure AddObj
*!*    *!*        Lparameters toTree,toNode,toObj
*!*    *!*    endproc

*!*    *----------------------------------------------------------------------------------------- AddObjPropertiesMethods
*!*    Procedure AddObjPropertiesMethods( ;
*!*            ; && form object
*!*        toTree as form ,;
*!*            ; && Node Object
*!*        toNode as MSComctlLib.Node ,;
*!*            ; && Object.focus()
*!*        toObj ,;
*!*            ;
*!*            tnObjs)

*!*        Local loNodes as MSComctlLib.Nodes
*!*        loNodes = toTree.Nodes

*!*        Set Step On
*!*        #If .t.
*!*            *    If toObj.name = ("Pageframe12")
*!*            *        Set Step On
*!*            *    endif

*!*            Local array aHprop(1)
*!*            local array aProp(1)

*!*            * nombre d'items dans la liste des proprits d'objets ajout au treeview
*!*            nCountPlist = Alen(toTree.plist,1)

*!*            gcPkey =    AddPropMethNode(toTree,toNode)
*!*            * chemin complet
*!*            cFullPath = loNodes.Item(toNode.Key).Fullpath

*!*            Local nProp as Integer,;
*!*                nHprop as Integer

*!*            Select (toTree.parent.aCFC)

*!*            Locate For objname = toObj.Name
*!*            If Found()==.f. and Empty(properties)==.t.
*!*                Return
*!*            endif

*!*            lnFin = Alines(aProperty,properties,4)

*!*            For each lcProp in aProperty
*!*                * limine _memberdata

*!*                *!*                if    Iif(lcProp="_memberdata",.f.,;
*!*                *!*                        ;
*!*                *!*                        Iif(At(".",lcProp)<At("=",lcProp) and At(".",lcProp)=toTree.cNop==.f. ,;
*!*                *!*                        ;&& Sous objet comme Commandbutton dans un commandgroup
*!*                *!*                    AddItemOfGroup(toTree,@toNode,toObj,At(".",lcProp)) ,;
*!*                *!*                        ; && proprit de l'objet
*!*                *!*                    .t.))

*!*                *!*                    loNodes.Add( ;
*!*                *!*                        ; && clef de la node
*!*                *!*                    gcPkey,4 ,;
*!*                *!*                        ; && clef parent
*!*                *!*                    "p"+Transform(d_Pcl) ,;
*!*                *!*                        ; && limine le nom de l'objet dans les sous objet
*!*                *!*                    Substr(aProperty(iL),Iif(aProperty(iL)=toTree.cNop,Len(toTree.cNop)+1,1)),;
*!*                *!*                        ; && node icone
*!*                *!*                    "imgP")
*!*                *            c=At(".",lcProp)<At("=",lcProp) and At(".",lcProp)=toTree.cNop==.f.
*!*                *            Iif(lcProp="_memberdata",.f.,iif(Iif(At(".",lcProp)<At("=",lcProp) and At(".",lcProp)=toTree.cNop==.f. ,AddItemOfGroup(toTree,@toNode,toObj,At(".",lcProp)),.t.))
*!*                If Iif(lcProp="_memberdata",.f.,;
*!*                        ;
*!*                        Iif("."$Left(lcProp,At("=",lcProp)) and ;
*!*                        ;
*!*                        Left(Alltrim(Left(lcProp,At("=",lcProp)-1)),At(".",Alltrim(Left(lcProp,At("=",lcProp)-1)))-1) ==toTree.cNop==.f.;
*!*                        ;
*!*                        ,AddItemOfGroup(toTree,@toNode,toObj,d_NameProp,@gcPkey,@tnObjs,d_lProperties),.t.))

*!*                    Declare toTree.plist(Iif(Empty(toTree.plist(d_Pcl)),0,1)+d_Pcl)

*!*                    loNodes.Add( ;
*!*                        ; && clef de la node
*!*                    gcPkey,4 ,;
*!*                        ; && clef parent
*!*                    "p"+Transform(d_Pcl) ,;
*!*                        ; && limine le nom de l'objet dans les sous objet
*!*                    Substr(lcProp,Iif(lcProp=toTree.cNop,Len(toTree.cNop)+1,1)),;
*!*                        ; && node icone
*!*                    "imgP"    )

*!*                    loNodes.Item(loNodes.Count).Expanded=.T.
*!*                    toTree.plist(d_Pcl)=cFullPath+"."+d_NameProp
*!*                    loNodes(loNodes.Count).EnsureVisible


*!*                endif

*!*            endfor

*!*        #else
*!*            Local Array aHprop(1)
*!*            llForm = Pemstatus( toObj.Parent, "Objects", 5 ) And toObj.Parent.BaseClass = "Form"
*!*            lnDebut = 1
*!*            lnFin = 1
*!*            Do Case

*!*                Case llForm
*!*                    Locate For objname = toObj.Name
*!*                    lnFin = Alines(aProperty,properties,4)
*!*                    toTree.cNop=""


*!*                Otherwise
*!*                    lnFin = Alines(aProperty,properties,4)
*!*                    lnDebut = Ascan(aProperty,toTree.cNop)

*!*            Endcase

*!*            If     Ascan(aProperty,"_memberdata") > 0
*!*                Adel(aProperty,Ascan(aProperty,"_memberdata"))
*!*                Declare aProperty(Alen(aProperty)-1)
*!*            Endif

*!*            lnFin   = Alen(aProperty,1)
*!*            ****************************************************************
*!*            * hritage
*!*            * aHprop
*!*            ****************************************************************
*!*            If !Empty(toObj.ClassLibrary)
*!*                cCurrAlias = Alias()

*!*                If ! Used(Juststem(toObj.ClassLibrary))
*!*                    Use (toObj.ClassLibrary) In 0
*!*                    cClassLibrary = Alias()
*!*                Endif
*!*                Select (Juststem(toObj.ClassLibrary))
*!*                Locate For Proper(objname)=toObj.Class
*!*                If Found()
*!*                    nHp = Alines(aHprop,properties,4)
*!*                Endif
*!*                Select(cCurrAlias)

*!*            Endif

*!*            nCountPlist = Alen(toTree.plist,1)
*!*            gcPkey = "kp"+Transform(Alen(toTree.plist,1))
*!*            loNodes.Add( toNode,4 ,gcPkey ,"Properties","imgP" )
*!*            cFullPath = loNodes.Item(toNode.Key).Fullpath

*!*            *!*            #Define d_Pcl    Alen(toTree.plist,1)
*!*            *!*            #Define d_HPcl    Alen(toTree.hPList,1)
*!*            *!*            #Define d_HMcl    Alen(toTree.hMList,1)
*!*            *!*            #Define d_NameProp Alltrim(Left(aProperty(iL),At("=",aProperty(iL))-1))
*!*            *!*            #Define d_NameHProp Alltrim(Left(aHprop(iH),At("=",aHprop(iH))-1))

*!*            For iL = lnDebut To lnFin

*!*                If "." $ Left(aProperty(iL),Atc("=",aProperty(iL))-1) = .F. .Or. Iif(Empty(toTree.cNop),.F., + aProperty(iL) = toTree.cNop)

*!*                    Declare toTree.plist(Iif(Empty(toTree.plist(d_Pcl)),0,1)+d_Pcl)
*!*                    loNodes.Add( ;
*!*                        ; && clef de la node
*!*                    gcPkey,4 ,;
*!*                        ; && clef parent
*!*                    "p"+Transform(d_Pcl) ,;
*!*                        ; && limine le nom de l'objet dans les sous objet
*!*                    Substr(aProperty(iL),Iif(aProperty(iL)=toTree.cNop,Len(toTree.cNop)+1,1)),;
*!*                        ; && node icone
*!*                    "imgP")

*!*                    loNodes.Item(loNodes.Count).Expanded=.T.

*!*                    toTree.plist(d_Pcl)=cFullPath+"."+d_NameProp

*!*                    If Empty(aHprop)
*!*                        Loop
*!*                    Endif
*!*                    * treeview.node.add.heritage
*!*                    iH = Ascan(aHprop,d_NameProp)

*!*                    Iif(iH>0,AddHProp2node("p"+Transform(d_Pcl),toTree,@aHprop,iH,toObj),"")

*!*                Else

*!*                    toTree.cNop = Left(aProperty(iL),Atc(".",aProperty(iL)))
*!*                    Exit

*!*                Endif

*!*            Endfor
*!*            If !Empty(aHprop)
*!*                iH = 1
*!*                Do While Empty(aHprop)==.F. And Iif( "." $ d_NameHProp==.F.,AddHProp2node(gcPkey,toTree,@aHprop,iH,toObj),.F.)
*!*                Enddo
*!*            Endif
*!*            #undefin d_Pcl


*!*            * ajoute la node Methods
*!*            nCountmlist = Alen(toTree.mlist,1)
*!*            gcPkey = "km"+Transform(Val(Substr(toNode.Key,2)))
*!*            loNodes.Add( toNode,4 ,gcPkey ,"Methods" )
*!*            loNodes(loNodes.Count).EnsureVisible

*!*            * form.obj1.obj...objN
*!*            cFullPath = Substr(loNodes.Item(toNode.Key).Fullpath,At(".",loNodes.Item(toNode.Key).Fullpath+".")+1)
*!*            lSameMethods = cFullPath = toTree.cPathTree
*!*            If toObj.name = ("Pageframe12")
*!*                Set Step On
*!*            endif

*!*            #Define d_poName Iif(Empty(toTree.cNoM),"",toObj.Name+".")
*!*            lnNextMeth = 1

*!*            cMthdOfObject = "PROCEDURE "+Iif(Empty(toTree.cNoM),"",toObj.Name+".")
*!*            For liM = 1 to Occurs(Chr(10)+cMthdOfObject,Chr(10)+methods)

*!*                * les mthodes du conteneur sont tous placs dans mthodes du conteneur parent
*!*                *!*            #Define p1  At(Chr(10)+cMthdOfObject+d_poName,Chr(10)+methods,liM)+Len(Chr(10)+cMthdOfObject+d_poName)
*!*                *!*            #Define p2  At(Chr(13),Substr(Chr(10)+methods,p1))-1
*!*                #Define p1  At(Chr(10)+cMthdOfObject,Chr(10)+methods,liM)+Len(Chr(10)+cMthdOfObject)
*!*                #Define p2  At(Chr(13),Substr(Chr(10)+methods,p1))-1
*!*                cMethode = Substr(Chr(10)+methods,p1,p2)
*!*                If "." $ cMethode = .F. .Or. ;
*!*                        ; && vrfie que c'est toujour sur le meme objet
*!*                    Iif(Empty(toTree.cNoM),.F.,  cMethode = toTree.cNoM)

*!*                    #Define d_Pcl    Alen(toTree.mlist,1)
*!*                    Declare toTree.mlist(Iif(Empty(toTree.mlist(d_Pcl,1)),0,1)+d_Pcl,2)
*!*                    loNodes.Add( gcPkey,4 ,"m"+Transform(Alen(toTree.mlist,1)) ,cMethode,"imgM" )
*!*                    toTree.mlist(d_Pcl,1)=cFullPath+Iif(Empty(cFullPath),"",".")+cMethode
*!*                Else

*!*                    *            toTree.cNoM = Left(cMethode,Atc(".",cMethode))
*!*                    Exit

*!*                Endif
*!*            Endfor
*!*            toTree.cPathTree = Iif("."$cFullPath,"",Left(cFullPath,rAt(".",cFullPath)-1))

*!*            Return lnFin
*!*        Endproc
*!*    #endif



*!*    Procedure AddHProp2node(eNodeParent,toTree,aHprop,iH,toObj)
*!*        If iH>0
*!*            * Incremente toTree.hPList
*!*            Declare toTree.hPList(Iif(Empty(toTree.hPList(d_HPcl)),0,1)+d_HPcl,2)

*!*            toTree.Nodes.Add( ;
*!*                ; && clef parent
*!*            eNodeParent,4 ,;
*!*                ; && clef de la node
*!*            "HP"+Transform(d_HPcl) ,;
*!*                ; && limine le nom de l'objet dans les sous objet
*!*            Substr(aHprop(iH),Iif(aHprop(iH)=toTree.cNop,Len(toTree.cNop)+1,1)),;
*!*                ; && node icone
*!*            "imgHp")


*!*            toTree.hPList(d_HPcl,1)= toObj.Class
*!*            toTree.hPList(d_HPcl,2)= toObj.ClassLibrary
*!*            * limine les proprites ajoutes
*!*            Adel(aHprop,iH)
*!*            Return .T.
*!*        Endif

