#Define d_nNav 10  && navigation nombre de nodes regardes
#Define d_cNavBackColorSelected Rgb(255,128,128)


Define Class mytree As OleControl
    OleClass = "MSComctlLib.TreeCtrl.2"
    *    LineStyle = 1
    *   style = 7
    Dimension aHierachy[1]

    Dimension aNav(d_nNav)  && navigation
    Dimension aImgKey(1,2)  && 1=Baseclass ou OleClass, 2=clef(ImageKey)
    Dimension aObjects[1]
    Dimension aItems[1]  && object item
    Dimension pList[1,2]   && liste des proprites par objet
    Dimension mList[1,2]   && liste des mthodes par objet
    Dimension hPList(1,2)    && liste des proprits hrites
    Dimension hMList(1,2)   && liste des mthodes hrites
    Dimension aSubCtrlInfo(1,4)   && NameGroupCtrl, properties of subsCtrl
    objectname = ""
    cObjPath = ""
    cObjTbl = ""
    cNop = ""                && next name object properties
    cNoM = ""                && next Name object Methods
    cPathTree = ""
    nItemCount = 1
    nObjectCount = 1
    oRoot = Null
    tableVS = ""

    Procedure oRoot_ASSIGN
        * when closing the referenced VFP designer, VFP will
        * nullify THIS.oRoot automatically! So we can use this
        * method as a kind of notification call back procedure
        Lparameters vNewVal
        This.oRoot = m.vNewVal

        With This && As MSComctlLib.TreeView
            If Isnull(m.vNewVal)
                * form/class designer was closed by user
                *   Set Step On
                *.Nodes.Clear    && that's dangerous because memory corruption C000005
                With .Nodes
                    For i = .Count To 1 Step -1
                        .Remove(i)
                    Endfor
                    .Clear
                Endwith
                Dimension .aHierachy[1]

                Dimension .aNav(d_nNav)  && navigation
                Dimension .aImgKey(1,2)  && 1=Baseclass ou OleClass, 2=clef(ImageKey)
                Dimension .aObjects[1]
                Dimension .aItems[1]  && object item
                Dimension .pList[1,2]   && liste des proprites par objet
                Dimension .mList[1,2]   && liste des mthodes par objet
                Dimension .hPList(1,2)    && liste des proprits hrites
                Dimension .hMList(1,2)   && liste des mthodes hrites
                Dimension .aSubCtrlInfo(1,4)   && NameGroupCtrl, properties of subsCtrl
                Store .F. To ;
                    .aNav ,;
                    .aImgKey ,;
                    .aObjects ,;
                    .aItems ,;
                    .pList ,;
                    .mList ,;
                    .hPList , ;
                    .hMList,;
                    .aSubCtrlInfo 
                Store "" To  ;
                    ; &&
                .objectname ;
                    ; &&
                , .cObjPath  ;
                    , .cObjTbl  ;
                    ; && next name object properties
                , .cNop  ;
                    ;&& next Name object Methods
                , .cNoM  ;
                    ; &&
                , .cPathTree ;
                    ; &&
                , .tableVS ;

                Store 1 To ;
                    .nItemCount ;
                    , .nObjectCount

                .oRoot = Null
                With Thisform
                    * .oTimer.Enabled = .T. And .lAutoTimer
                    * Activate Screen

                    * met  -1 .aCFC(n,1) et ou n = mytree(N)
                    .acfc(Int(Val(Substr(This.Name,Len("mytree")+1))),1)=-1
                Endwith

            Else
                *  Thisform.oTimer.Enabled = .f. And Thisform.lAutoTimer
            Endif
        Endwith
    Endproc

    Function mkTree
        Parameters toObject As Container, ;
            toParent As TreeNode , ;
            tlNoAddPropMeth As Logical

        Local loNode, lnObjs, lnObj, loObj
        loNode = This.AddNode( toObject, toParent )
        AddPropMethNode(This,loNode,toObject)

        Do Case
                *+* Try add support for formsets:
            Case toObject.BaseClass = "Formset" && a formset cannot be selected! So this won't work this way!
                lnObjs = toObject.FormCount
                * still not working... :-)
            Case toObject.BaseClass = "Grid"
                * grid.objects is broken,
                * so no inner grid support at this time.
                * which would be really nice.
                * waiting since 2005 for MS to fix this bug.
                lnObjs = toObject.ColumnCount
            Case Pemstatus( toObject, "Objects", 5 )
                lnObjs = toObject.Objects.Count
            Otherwise
                lnObjs = 0
        Endcase

        If tlNoAddPropMeth==.F.
            For lnObj = 1 To lnObjs
                loObj = toObject.Objects[lnObj]
                This.mkTree( loObj, loNode )
            Endfor
        Endif
        Return loNode
    Endfunc


    Procedure AddNode
        Lparameters toObj As Object, ;
            toParent As TreeViewNode  && I wonder if there is a "right type" for this?

        Local lcKey, loNode As TreeViewNode

        This.nItemCount = This.nItemCount + 1
        Dimension This.aItems[this.nItemCount]
        This.aItems[this.nItemCount] = toObj

        * Why a+?
        * cuz the @#$#@ treeview doesnlt like "1" or 1 as a key, but "a1" is ok.
        lcKey = "a" + Transform(This.nItemCount)
        With toObj
            #Define    d_ImgKey  Ascan(Thisform.aImgKey,Iif(Proper(.BaseClass)="Olecontrol",Proper(.OleClass),Proper(.BaseClass)),1,-1,1,9)
            If Vartype( toParent ) = "O"
                * Hang this node under the parent
                This.Nodes.Add( toParent, 4, lcKey, .Name,.BaseClass)
                *   this.Nodes.Add( toParent, 4, lcKey, .Name,d_ImgKey)
            Else
                * make the root
                This.Nodes.Add( , , lcKey, toObj.Name,.BaseClass )
            Endif
            loNode = This.Nodes[ lcKey ]
        Endwith

        * cPath = Justpath(Substr(Sys(16),Iif(Sys(16)="PROCEDURE",At(" ",Sys(16),2),1))) +"\aNalyse_objet.prg"

        Return loNode
    Endproc


    *
    * ******************************************************
    * * init
    * ******************************************************
    **  Cr par            : Eddy Maue
    * * Cr le             : 03/31/06
    * * Modifier le         :
    * ******************************************************
    Procedure Init
        Lparameters toRoot,tcTableVS
        With This
            * With .Object
            .LineStyle = 1
            .Font.Size = 7
            .indentation = 10
            *     With .tree1
            * endwith
            .ImageList=Thisform.MyImageList1.Object
            * .Visible = .T.
            .Top = 2
            .Left = 2
            .Width = Thisform.Width - 2
            .Height = Thisform.Height - 37
            .Anchor = 15
            .PathSeparator="."
            *    EndWith
            .tableVS = m.tcTableVS
            .oRoot = m.toRoot
            .mkTree(toRoot)

        Endwith


        * ******************************************************
        * * Navigation(oNode)
        * ******************************************************
        **  Cr par            : Eddy Maue
        * * Cr le             : 05/19/07
        * * Modifier le         :
        * ******************************************************
    Procedure Navigation(oNode As MSComctlLib.Node)

        _Screen.LockScreen=.T.
        =Adel(This.aNav,1)
        This.aNav(10)= oNode
        oNode.BackColor= d_cNavBackColorSelected
        If Vartype(This.aNav(9))="O"
            This.aNav(9).BackColor = Rgb(255,255,255)
        Endif
        _Screen.LockScreen=.F.
    Endproc && Navigation(oNode)

    *  /
    * / ScanTreeWithFullPath   : Eddy Maue  --   Crer le :04/12/07
    Procedure FindNodeWithFullPath(tcPath As Character)
        ln = Ascan(This.pList,tcPath ,1,-1,1,1+8)

        If ln=0
            * nouvel objet ajout
            Return .F.

        Else
            Return This.Nodes.Item("p"+Transform(ln)).Parent.Parent

        Endif
    Endproc

    Procedure NodeClick
        Lparameters oNode As Object
        Local lnIndex As Integer,;
            loObj As Object,;
            loTemp As Object,;
            loPage As Object,;
            lcWindow As Character,;
            lcWCaption As Character,;
            llInsidePage As Boolean,;
            lnLoop As Integer

        Local oNode As MSComctlLib.Nodes

        This.Navigation(oNode)

        Do Case
            Case oNode.Key="p"

                nPosEgale = At("=",oNode.Text)
                cValue = Chrtran(Substr(oNode.Text,nPosEgale+2),["],"")
                cValue = Inputbox("Proprit --> "+oNode.Text,"Modifier",cValue,0,"",cValue)
                cProp = Left(oNode.Text,nPosEgale-2)

                With This.aItems(Val(Substr(oNode.Parent.Parent.Key,2)))

                    Do Case
                        Case Type("."+cProp)= "N"
                            cGoodValue = Iif(","$cValue,"rgb("+cValue+")",cValue)
                            Execscript("."+cProp+"="+cGoodValue)
                            oNode.Text = cProp+" = "+cValue

                        Case Type("."+cProp) = "D"

                        Case Type("."+cProp) = "C"

                            Execscript("."+cProp+"='"+cValue+"'")

                            oNode.Text = cProp+" = '"+cValue+"'"
                    Endcase

                Endwith
                Return
            Case oNode.Key = "m"

                If File(This.objectname)
                    Do Case
                        Case "scx" = Justext(This.objectname)
                            nSel = Aselobj(aObj,3)
                            If aObj(1).BaseClass = "Form" == .F.
                                Activate Window (This.aItems(2).Caption)
                                This.aItems(3).SetFocus()
                            Endif
                            *Set Step On
                            cScript = [modify form ("]+This.objectname+[") nowa method ] + Strtran( Substr(oNode.Fullpath,At(".",oNode.Fullpath)+1) ,"Methods.","")
                            * cScript = [Modify Form ("]+this.objectname+[") nowa method ]+this.mList(Int(Val(Substr(oNode.Key,2))),1)
                            &cScript

                        Case "vcx" = Justext(This.objectname)

                    Endcase
                Endif
                Return
            Case oNode.Key = "k"
                Return
            Case oNode.Key = "hp"  && hritage property
                * this.hPList(x,y) x = classname et y = classe location
        Endcase

        Store Int(Val(Substr(oNode.Key,2))) To lnIndex
        Store This.aItems[lnIndex] To loObj
        Store Null To loTemp, loPage
        Store "" To lcWindow, lcWCaption
        Store .F. To llInsidePage
        Store 0 To lnLoop
        * this.oRoot.BackColor = this.oRoot.BackColor
        * Remember Mouse Position
        *+* save form caption for restoring mouse position
        lcWindow = Thisform.Caption
        *~* remember mouse pos relative to thiss window
        lnMouseTop = Mrow(lcWindow,3)
        lnMouseLeft = Mcol(lcWindow,3)
        *
        * Get objects window caption
        *+* better code to find the outmost parent form
        * in design mode *with_and_without* a caption!
        NOTE: If we have ANY class designer window open there is ALWAYS
        * an outer (containing) form reference available. Even more:
        * its a FORMSET containing the class in design mode there!! ;
        We can say: It doesn't matter if we are working on a .SCX (form/formset) or ;
        a .VCX containing a form/formset or ANY other class. We can always traverse ;
        the parent containment hierachy upward ending up somewhere within a form ;
        (having a caption for sure) - even in a class designer window containing a textbox only!

        loTemp = loObj
        lcWCaption = Iif(Not Type("loTemp.Caption") == "U", loObj.Caption, "")
        Do While Not Type("loTemp.Parent") == "U"
            loTemp = loTemp.Parent
            lcWCaption = Iif(Not Type("loTemp.Caption") == "U", loTemp.Caption, lcWCaption)
            *
            *+* additional code is needed when addressing objects contained inside pageframes!
            * If we want to simulate a mouse click on an object contained on a page of a pageframe,
            * we first have to ensure the page is activated. This is pretty easy if that object has a
            * SetFocus() method. But if it hasn't, we have to activate the containing page manually!
            * At first we only set a flag, if there is a page "upstairs" in the containment hierachy
            llInsidePage = llInsidePage Or (loTemp.BaseClass == "Page")
            *
        Enddo
        *
        If llInsidePage
            * If our object resides somewhere inside a page(frame) we start collecting all object
            * references up until we reach the form (either a "real" form (a scx- or vcx-based one),
            * or the form of the class designers special outer formset).
            This.TraverseHierachy(loObj)
        Else
            * otherwise this isn't necessary. We store only one (the actual objects) reference
            Dimension This.aHierachy[1]
            This.aHierachy[1] = loObj
        Endif
        *
        For lnLoop = Alen(This.aHierachy) To 1 Step -1
            * THIS.ObjectClick(loObj, lcWCaption)
            This.ObjectClick(This.aHierachy[lnLoop], lcWCaption)
        Next
        * when done with this it's better not to keep to much object references in THIS objects
        * .aHierachy array
        Dimension This.aHierachy[1]
        Store Null To aHierachy
        * Finally restor mouse position (w/o re-clicking :-)
        Mouse At (lnMouseTop),(lnMouseLeft) Pixels Window (lcWindow)
        Activate Window (lcWindow)
    Endproc

    Procedure TraverseHierachy
        Lparameters toObject As Object
        Local loTemp As Object, lnAlen As Integer
        With This
            Dimension .aHierachy[1]
            .aHierachy[1] = toObject
            loTemp = toObject.Parent
            lnAlen = 1
            Do While Not loTemp.BaseClass == "Form"
                lnAlen = lnAlen + 1
                Dimension .aHierachy[lnAlen]
                .aHierachy[lnAlen] = loTemp
                loTemp = loTemp.Parent
            Enddo
        Endwith
    Endproc

    Procedure ObjectClick
        * ToDOs:
        * When clicking on a form-node in the class-tree it is possible
        * that another object (inside the containing form) covers the area
        * we are going to click => not the form gets selected, but another
        * object inside (that's not what we wanted!)

        Lparameters toObject As Object, tcWindCaption As String
        Local lnTop As Integer ,;
            lnLeft As Integer ,;
            llHideTabs As Boolean ,;
            llChanged As Boolean

        If toObject.BaseClass == "Page" And toObject.Parent.Tabs = .F.
            llHideTabs = .T.
            llChanged = Sys(1269, toObject.Parent, "Tabs", 0)
            toObject.Parent.Tabs = .T.
        Else
            llHideTabs = .F.
        Endif
        *
        * Get the object position relative to a form
        lnTop = Objtoclient(toObject,1)
        lnLeft = Objtoclient(toObject,2)
        *
        If Pemstatus(toObject, "Setfocus", 5)
            toObject.SetFocus()
        Endif
        *
        If Not Empty(tcWindCaption)
            *+* ShiftControl-Click will drill down directly! This do the trick (since VFP7.0 or 8.0) ?
            Try
                Mouse Click At (lnTop),(lnLeft) Pixels Window (tcWindCaption) Shift Control
            Catch
                * eat errors thrown when selecting objects in a grid column (eg default textboxes there)
            Endtry
        Endif
        *
        DoEvents
        *
        If llHideTabs
            If llChanged
                toObject.Parent.Tabs = .F.
            Else
                toObject.Parent.ResetToDefault("Tabs")
            Endif
        Endif
    Endproc
Enddefine
*************** new version 3.0 EOF
